<?php

# ***** BEGIN LICENSE BLOCK *****
# This file is part of icoinCoin translator plugin for DotClear 1.2.3.
# Copyright (c) 2006 Mikal Pirio and contributors. All rights
# reserved.
#
# coinCoin translator is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2
# as published by the Free Software Foundation.
#
# coinCoin translator is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with coinCoin translator; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****


class coinCoin {

	var $lang;
	var $repeat;

	function coinCoin($lang='coin', $repeat=true) {
		$this->lang = $lang;
		$this->repeat = $repeat;
	}

	function setLang($lang='coin') {
		$this->lang=$lang;
	}

	function getLang() {
		return $this->lang;
	}

	function getNameLanguage() {
		return strtolower($this->lang).ucfirst(strtolower($this->lang));
	}

	function translate() {
		$fields_news = array('post_chapo', 'post_content','post_notes', 'post_titre');
		$fields_comments = array('comment_content');

		if(!empty($GLOBALS['news'])) {
			while ($GLOBALS['news']->fetch()) {
				foreach($fields_news as $f) {
					$str = $GLOBALS['news']->f($f);

					$str = preg_replace_callback('/\w+/',array(&$this, '_translation'),$str);
					$GLOBALS['news']->setField($f, $str);
				}

				$post_titre_url = $GLOBALS['news']->f('post_titre_url').'&coincoin=1';
				$GLOBALS['news']->setField('post_titre_url',$post_titre_url);
			}
		}

		if(!empty($GLOBALS['comments'])) {
			while ($GLOBALS['comments']->fetch()) {
        	                foreach($fields_comments as $f) {
                	                $str = $GLOBALS['comments']->f($f);

	                                $str = preg_replace_callback('/\w+/',array(&$this, '_translation'),$str);
	                                $GLOBALS['comments']->setField($f, $str);
        	                }
                	}
		}
	}

	function _translation($matches) {
		$word = $this->_rand_ctoupper($this->lang);
		if($this->repeat) {
                	srand();
                        $rand = rand(1,2);
                        $word = str_repeat($word, $rand);
		}

                return $word;
	}

	function link() {
		global $coincoin;
		$url = $_SERVER["REQUEST_URI"];

		if ($coincoin != '') {
			$url = preg_replace('/(\?|&)?coincoin=1/','',$url);
			echo '<a href="'.$url.'">'.__('Translate to normal language').'</a>';
		}
		else {
			if(!empty($_SERVER['QUERY_STRING'])) $url.= '&coincoin=1';
			else $url.='?coincoin=1';
			echo '<a href="'.$url.'">'.sprintf(__('Translate to %s'), $this->getNameLanguage()).'</a>';
		}
	}

	# fonction qui met en majuscules certaines lettres alatoirement
	function _rand_ctoupper($str) {
       		for ($i=0; $i < strlen($str); $i++) {
                	srand();
                	$rand = rand(0, 1);
                	if($rand) $str{$i} = strtoupper($str{$i});
        	}

        	return $str;
	}

}

$coincoin = ( !empty($_GET['coincoin']) ? $_GET['coincoin'] : '' );

if (defined('DC_LANG')) {
        if (dc_encoding == 'UTF-8') {
                l10n::set(dirname(__FILE__).'/l10n/'.DC_LANG.'-utf8/main');
        }
        else {
                l10n::set(dirname(__FILE__).'/l10n/'.DC_LANG.'/main');
        }
}

if ($coincoin != '') {
	define('DC_UPDATE_FILE',dirname(__FILE__).'/../../../index.php');
        files::touch(DC_UPDATE_FILE);
}

?>
